%% Generate the Drivera database
% ----------------------------------------------------------------------- %
% Alexandru Paul Condurache, Johannes Kotzerke and Alfred Mertins,
% "Robust retina-based person authentication using the sparse classifier.", 2012.
% ----------------------------------------------------------------------- %
% For generating the Drivera database you need to fill in the path to the
% images of the DRIVE database on your computer.
pathRead = 'DRIVE/test/images/';
pathWrite = 'DRIVERA/';
pathM = '.';
fileExtension = 'tif';
files = dir([pathRead '*.' fileExtension]);
% ----------------------------------------------------------------------- %


% ----------------------------------------------------------------------- %
% Generating the Drivera140
% ----------------------------------------------------------------------- %
database = 'DRIVERA140';
if ~isdir([pathWrite database])
    mkdir([pathWrite database])
end
load([pathM '/' lower(database) '.mat'], 'M');

if numel(files) ~= 20
    error('Something went wrong. The DRIVE database should have 20 images inside the test-dir.');
end

quantity = length(M)/numel(files);

for i = 1:numel(files)
    retina = imread([pathRead files(i).name]);
    % Take the green channel.
    retinag = retina(:,:,2);
    for j = 1:quantity
        retinag_ = transformImage(M{(i-1)*quantity + j}, retinag);
        imwrite(retinag_, [pathWrite database '/drivera_' num2str((i-1)*quantity + j) '.png']);
    end
end
% ----------------------------------------------------------------------- %



% ----------------------------------------------------------------------- %
% Generating the Drivera280
% ----------------------------------------------------------------------- %
database = 'DRIVERA280';
if ~isdir([pathWrite database])
    mkdir([pathWrite database])
end
load([pathM '/' lower(database) '.mat'], 'M');

if numel(files) ~= 20
    error('Something went wrong. The DRIVE database should have 20 images inside the test-dir.');
end

quantity = length(M)/numel(files);

for i = 1:numel(files)
    retina = imread([pathRead files(i).name]);
    % Take the green channel.
    retinag = retina(:,:,2);
    for j = 1:quantity
        retinag_ = transformImage(M{(i-1)*quantity + j}, retinag);
        imwrite(retinag_, [pathWrite database '/drivera_' num2str((i-1)*quantity + j) '.png']);
    end
end
% ----------------------------------------------------------------------- %